/******************************************************************************/
/*	aisa25s.c																  */
/*																			  */
/*	aISA-A25Tv\[X													  */
/*																			  */
/*	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.									  */
/*																			  */
/*	Date 1998/11/17															  */
/*																			  */
/*	̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B					  */
/*																			  */
/******************************************************************************/


#define	STRICT
#include	<windows.h>
#include	<tchar.h>
#include	<math.h>

#include "aisa25w.h"


const TCHAR szTitle[] = _T("Sample");
const TCHAR szA25[]	 = _T("aISA-A25");

static BOOL StartProc(PWORD pwLogSlot);
static BOOL EndProc(WORD wLogSlot);
static BOOL AdProc(WORD wLogSlot);
static BOOL DaProc(WORD wLogSlot);
static BOOL PioProc(WORD wLogSlot);

static WORD AdProcGetNextChAddr(WORD wFirst, WORD wLast, WORD wCur);
static void DaProcMakeSineData(PDWORD pdwDataCount, PWORD* ppwData);

static void ResultMessage(LPCTSTR lpszbuf);
static void ErrorMessage(WORD wLogSlot);


int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	WORD wLogSlot;

	/*----------------------------------------------*/
	/*	Jn									*/
	/*----------------------------------------------*/
	if (StartProc(&wLogSlot) == FALSE)
		return 1;

	/*----------------------------------------------*/
	/*	A/D 									*/
	/*----------------------------------------------*/
	if (AdProc(wLogSlot) == FALSE)
	{
		EndProc(wLogSlot);
		return 1;
	}

	/*----------------------------------------------*/
	/*	D/A 									*/
	/*----------------------------------------------*/
	if (DaProc(wLogSlot) == FALSE)
	{
		EndProc(wLogSlot);
		return 1;
	}

	/*----------------------------------------------*/
	/*	PIO 									*/
	/*----------------------------------------------*/
	if (PioProc(wLogSlot) == FALSE)
	{
		EndProc(wLogSlot);
		return 1;
	}

	/*----------------------------------------------*/
	/*	I									*/
	/*----------------------------------------------*/
	if (EndProc(wLogSlot) == FALSE)
		return 1;

	return 0;
}

/*--------------------------------------------------------------------------*/
/*	Jn																*/
/*--------------------------------------------------------------------------*/
static BOOL StartProc(PWORD pwLogSlot)
{
	TCHAR		   szbuf[256];			// ƃobt@
	DWORD		   dwDLLVer, dwDrvVer;	// o[W
	BOOL		   bResult;				// 
	WORD		   wLogSlot;			// _Xbg
	AISA25RESOURCE ri;					// \[X
	WORD		   wNumBoard;			// 䂷{[h
	DWORD		   dwSwitchValue;		// BSN

	/*----------------------------------------------*/
	/*	aisa25.dll ̎gp錾						*/
	/*----------------------------------------------*/
	if (Aisa25wDllOpen() == FALSE)
	{
		ErrorMessage(AISA25_SLOT_AUTO);
		return FALSE;			// aisa25.dll ̃[hɎs܂
	}

	/*----------------------------------------------*/
	/*	o[Wԍ\							*/
	/*	aISA-A25 DLL,Driver̃o[Wԍ擾		*/
	/*----------------------------------------------*/
	if (Aisa25wGetVersion(&dwDLLVer, &dwDrvVer) == FALSE)
	{
		ErrorMessage(AISA25_SLOT_AUTO);
		return FALSE;
	}

	wsprintf(szbuf, _T("GetVersion\n")
					_T("DLL Version: %08lxh\n")
					_T("Drv Version: %08lxh"),
					dwDLLVer,
					dwDrvVer);
	ResultMessage(szbuf);

	/*----------------------------------------------*/
	/*	aISA-A25̎gp錾						*/
	/*----------------------------------------------*/
	wLogSlot = AISA25_SLOT_AUTO;		// gp̃foCXT܂B
	bResult = Aisa25wCreate(&wLogSlot,	// ꍇA̎̃foCXi[܂B
							NULL,		// EBhEnhȂ̂NULLZbg܂B
										// EBhEnhZbg΁A
										// e탁bZ[W܂B
							0x6401,		// 3ԖڂɃZbgẮAbZ[WID̊
										// ƂȂlłBۂ̃bZ[WID͂̊lɃI
										// tZbg(WM_EOCȂ)̂ƂȂ܂B
							NULL);		// NULL Zbg܂B

	if (bResult == FALSE)		// foCX܂B
	{
		ErrorMessage(AISA25_SLOT_AUTO);
		return FALSE;
	}

	wsprintf(szbuf, _T("aISA-A25 Created\n\n")
					_T("LogSlot: %2d"),
					 wLogSlot);

	ResultMessage(szbuf);

	/*----------------------------------------------*/
	/*	\[X擾							*/
	/*----------------------------------------------*/
	if (Aisa25wGetResource(wLogSlot, &ri) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return FALSE;
	}

	/*----------------------------------------------*/
	/*	䂷{[h擾						*/
	/*----------------------------------------------*/
	if (Aisa25wGetNumBoard(wLogSlot, &wNumBoard) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return FALSE;
	}

	/*----------------------------------------------*/
	/*	BSN ̒l擾								*/
	/*----------------------------------------------*/
	if (Aisa25wGetSwitchValue(wLogSlot, &dwSwitchValue) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return FALSE;
	}

	wsprintf(szbuf, _T("Board Name: %s\n")
					_T("NumPorts: %2d\n")
					_T("IO Address: %04xh-%04xh\n")
					_T("IRQ: %2d\n")
					_T("Num Board: %2d\n")
					_T("BSN: %02xh"),
					szA25,
					ri.dwIOPortLength[0],
					ri.dwIOPortBase[0], ri.dwIOPortBase[0] + ri.dwIOPortLength[0] - 1,
					ri.dwIRQRegisters[0],
					wNumBoard,
					dwSwitchValue);

	ResultMessage(szbuf);

	// _Xbgf[^ZbgĕԂ܂B
	*pwLogSlot = wLogSlot;

	return TRUE;
}

/*--------------------------------------------------------------------------*/
/*	I																*/
/*--------------------------------------------------------------------------*/
static BOOL EndProc(WORD wLogSlot)
{
	/*----------------------------------------------*/
	/*	aISA-A25 ̎gpJ						*/
	/*----------------------------------------------*/
	if (Aisa25wClose(wLogSlot) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return FALSE;
	}

	ResultMessage(_T("aISA-A25 Closed"));

	/*----------------------------------------------*/
	/*	aisa25.dll ̎gpJ						*/
	/*----------------------------------------------*/
	if (Aisa25wDllClose() == FALSE)
	{
		MessageBox(NULL, _T("DLL Unload error"), szTitle, MB_OK | MB_ICONSTOP);
		return FALSE;			// aisa25.dll ̃A[hɎs܂B
	}

	return TRUE;
}

/*--------------------------------------------------------------------------*/
/*	A/D 																*/
/*--------------------------------------------------------------------------*/
static BOOL AdProc(WORD wLogSlot)
{
	TCHAR szbuf[4096], szTmp[100];			// ƃobt@
	AISA25ADCHE	 che[AISA25_AD_CH_ADDR_MAX];// CH Gg RAM
	DWORD		 dwChCount;					// CH Gg
	AISA25ADMODE mode;						// TvO샂[h
	DWORD dwNumData;						// TvOf[^
	DWORD dwStatus;							// TvOXe[^X

	PWORD pwData;							// TvOf[^
	WORD  wChCur, wChFirst, wChLast;		// `lCNg
	LONG  i;

	/*----------------------------------------------*/
	/*	A/D Ro[^̃Lu[V			*/
	/*----------------------------------------------*/
	if (Aisa25wAdc(wLogSlot) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return FALSE;
	}

	ResultMessage(_T("A/D Ro[^Lu[V"));

	/*----------------------------------------------*/
	/*	A/D CH Gg RAM ̓e擾			*/
	/*----------------------------------------------*/
	dwChCount = AISA25_AD_CH_ADDR_MAX;		// CH Gg

	if (Aisa25wAdGetChEntry(wLogSlot, dwChCount, che) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return FALSE;
	}

	wsprintf(szbuf, _T("A/D CH Gg RAM ̓e擾\n"));

	for (i = 0; i < (int)dwChCount; i++)
	{
		wsprintf(szTmp, _T("Addr:%02xh  CH:%02d  SdBu:%d  Gain:%2d\n"),
							i,
							che[i].dwChAnalog + 1,
							che[i].dwSdBu,
							che[i].dwGain);

		strcat(szbuf, szTmp);
	}

	ResultMessage(szbuf);

	/*----------------------------------------------*/
	/*	A/D CH Gg RAM ̓o^					*/
	/*----------------------------------------------*/
	for (i = 0; i < (int)dwChCount; i++)
		che[i].dwGain = AISA25_AD_GAIN_50;		// QCύX

	if (Aisa25wAdSetChEntry(wLogSlot, dwChCount, che) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return FALSE;
	}

	ResultMessage(_T("A/D CH Gg RAM ̓eo^"));

	/*----------------------------------------------*/
	/*	A/D TvO샂[hݒ				*/
	/*----------------------------------------------*/
	mode.dwMode		   = AISA25_AD_MODE_01;		// 샂[h
	mode.dwChAddrFirst = AISA25_AD_CH_0H;		// TvOJn`lAhX
	mode.dwChAddrLast  = AISA25_AD_CH_FH;		// TvOI`lAhX
	mode.dwSelCnvRate  = AISA25_AD_RATE_HIGH;	// ϊx
	mode.dwSelClock	   = AISA25_AD_CLOCK_10M;	// TvONbN
	mode.dwTimer	   = 100;					// TvO^C}
	mode.dwCount	   = 50;					// TvO񐔂ݒ
	mode.dwBuffer	   = 50;					// obt@TCY
	mode.dwScn		   = 0;						// e{[h EAB XLԍ(SCN)
												// }X^{[hɃ^[Qbg{[h
												// ڑĂꍇ́ASCN ݒ
												// ĂB

	if (Aisa25wAdSetMode(wLogSlot, &mode) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return FALSE;
	}

	ResultMessage(_T("A/D TvO샂[hݒ"));

	/*----------------------------------------------*/
	/*	A/D TvO̊Jn						*/
	/*----------------------------------------------*/
	if (Aisa25wAdStartSampling(wLogSlot) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return FALSE;
	}

	ResultMessage(_T("A/D TvOJn"));

	/*----------------------------------------------*/
	/*	A/D TvO̒~						*/
	/*----------------------------------------------*/
	if (Aisa25wAdStopSampling(wLogSlot) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return FALSE;
	}

	ResultMessage(_T("A/D TvO~"));

	/*----------------------------------------------*/
	/*	A/D TvȌԂ擾				*/
	/*----------------------------------------------*/
	if (Aisa25wAdGetSamplingStatus(wLogSlot, &dwNumData, &dwStatus) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return FALSE;
	}

	wsprintf(szbuf, _T("A/D TvOEXe[^X擾\n")
					_T("f[^=%ld\n")
					_T("Xe[^X=%lx"),
					dwNumData, dwStatus);

	ResultMessage(szbuf);


	// TvOf[^Ƃ
	if (dwNumData == 0)
		return TRUE;

	/*----------------------------------------------*/
	/*	A/D TvOf[^̎擾				*/
	/*----------------------------------------------*/
	pwData = (PWORD)malloc(dwNumData * sizeof(WORD));	// ̈m

	if (Aisa25wAdGetData(wLogSlot, &dwNumData, pwData) == FALSE)
	{
		ErrorMessage(wLogSlot);

		free(pwData);		// ̈

		return FALSE;
	}

	wChCur	 = (WORD)mode.dwChAddrFirst; // Jn`lAhX
	wChFirst = (WORD)mode.dwChAddrFirst; // Jn`lAhX
	wChLast	 = (WORD)mode.dwChAddrLast;	 // I`lAhX

	wsprintf(szbuf, _T("A/D TvOf[^擾\n"));

	for (i = 0; i < (LONG)dwNumData && lstrlen(szbuf) < sizeof(szbuf) - sizeof(szTmp) ; i++)
	{
		wsprintf(szTmp, _T("Addr:%02xh CH%02d:%04xh  "),
							wChCur,
							che[wChCur].dwChAnalog + 1,
							pwData[i]);

		strcat(szbuf, szTmp);

		if ((i + 1) % 4 == 0)	// 4 Ŋ؂
			strcat(szbuf, _T("\n"));

		// ̎QƃAhX
		wChCur = AdProcGetNextChAddr(wChFirst, wChLast, wChCur);
	}

	free(pwData);				// ̈

	ResultMessage(szbuf);

	return TRUE;
}

/*--------------------------------------------------------------------------*/
/*	D/A 																*/
/*--------------------------------------------------------------------------*/
static BOOL DaProc(WORD wLogSlot)
{
	TCHAR szbuf[256];					// ƃobt@
	DWORD dwSelClock;					// TvONbN
	DWORD dwTimer;						// TvO^C}
	DWORD dwDaMode;						// D/A [h
	DWORD dwDataCount;					// D/A f[^o^
	PWORD pwDataEntry;					// D/A TvOf[^
	WORD  wDaData;						// D/A f[^

	/*----------------------------------------------*/
	/*	D/A TvOx̐ݒ					*/
	/*----------------------------------------------*/
	dwSelClock = AISA25_DA_CLOCK_10M;	// 10MHz
	dwTimer	   = 1000;

	if (Aisa25wDaSetRateSampling(wLogSlot, dwSelClock, dwTimer) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return FALSE;
	}

	ResultMessage(_T("D/A TvONbNݒ"));

	/*----------------------------------------------*/
	/*	D/A g`f[^̓o^						*/
	/*----------------------------------------------*/
	dwDaMode = AISA25_DA_MODE_ALL;		// ALL [hŃf[^o^

										// g`f[^쐬
	DaProcMakeSineData(&dwDataCount, &pwDataEntry);

	if (Aisa25wDaSetDataEntry(wLogSlot, dwDaMode, dwDataCount, pwDataEntry) == FALSE)
	{
		ErrorMessage(wLogSlot);

		free(pwDataEntry);				// g`f[^

		return FALSE;
	}

	free(pwDataEntry);					// g`f[^

	ResultMessage(_T("D/A g`f[^o^"));

	/*----------------------------------------------*/
	/*	D/A TvOJn						*/
	/*----------------------------------------------*/
	dwDaMode = AISA25_DA_MODE_ALL;		// ALL [hŃTvO܂B

	if (Aisa25wDaStartSampling(wLogSlot, dwDaMode) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return FALSE;
	}

	ResultMessage(_T("D/A TvOJn"));

	/*----------------------------------------------*/
	/*	D/A TvO~						*/
	/*----------------------------------------------*/
	if (Aisa25wDaStopSampling(wLogSlot) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return FALSE;
	}

	ResultMessage(_T("D/A TvO~"));

	/*----------------------------------------------*/
	/*	D/A f[^𒼐ڏo						*/
	/*----------------------------------------------*/
	wDaData = 0x8000;

	if (Aisa25wDaSetData(wLogSlot, wDaData) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return FALSE;
	}

	wsprintf(szbuf, _T("D/A f[^o\n")
					_T("Data: %04xh"),
					wDaData);

	ResultMessage(szbuf);

	return TRUE;
}

/*--------------------------------------------------------------------------*/
/*	PIO 																*/
/*--------------------------------------------------------------------------*/
static BOOL PioProc(WORD wLogSlot)
{
	TCHAR szbuf[256];					// ƃobt@
	DWORD dwEIn1,  dwEIn2,	dwEIn3;		// ėp
	DWORD dwEOut1, dwEOut2, dwEOut3;	// ėpo

	/*----------------------------------------------*/
	/*	ėpo͂ǂݍ						*/
	/*----------------------------------------------*/
	if (Aisa25wGetEIn(wLogSlot, &dwEIn1, &dwEIn2, &dwEIn3) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return FALSE;
	}

	wsprintf(szbuf, _T("ėp͂̓e\n")
					_T("EIn1: %xh\n")
					_T("EIn2: %xh\n")
					_T("EIn3: %xh"),
					dwEIn1, dwEIn2, dwEIn3);

	ResultMessage(szbuf);

	/*----------------------------------------------*/
	/*	ėpo͂֏o							*/
	/*----------------------------------------------*/
	dwEOut1 = AISA25_EIO_ON;
	dwEOut2 = AISA25_EIO_OFF;
	dwEOut3 = AISA25_EIO_ON;

	if (Aisa25wSetEOut(wLogSlot, dwEOut1, dwEOut2, dwEOut3) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return FALSE;
	}

	wsprintf(szbuf, _T("ėpo͂̓e\n")
					_T("EOut1: %xh\n")
					_T("EOut2: %xh\n")
					_T("EOut3: %xh"),
					dwEOut1, dwEOut2, dwEOut3);

	ResultMessage(szbuf);

	return TRUE;
}

/*--------------------------------------------------------------------------*/
/* `lCNgTvO̎̎QƃAhX					*/
/*--------------------------------------------------------------------------*/
static WORD AdProcGetNextChAddr(WORD wFirst, WORD wLast, WORD wCur)
{
	// Jn`lAhXƏI`lAhX
	// ȂCNgȂ
	if (wFirst == wLast)
		return wCur;

	wCur++;

	// ŏIAhX𒴂A擪AhXԂ
	if (AISA25_AD_CH_ADDR_LAST < wCur)
		return AISA25_AD_CH_ADDR_FIRST;

	// JnAhXIAhX傫A
	// JnAhXCNgl傫ꍇ
	if (wFirst > wLast && wCur > wFirst)
		return wCur;

	// IAhX傫ꍇ
	if (wLast < wCur)
		return AISA25_AD_CH_ADDR_FIRST;

	return wCur;
}

/*--------------------------------------------------------------------------*/
/*	TCgf[^̍쐬													*/
/*		-10V -> +10V -> +10V												*/
/*--------------------------------------------------------------------------*/
static void DaProcMakeSineData(PDWORD pdwDataCount, PWORD* ppwData)
{
	DWORD dwDataCount = 360;
	DWORD dwData = 0;
	WORD  wData = 0, wWork;

	// f[^i[̈m
	*ppwData = (PWORD)malloc(dwDataCount * sizeof(WORD));

	for (; dwData < dwDataCount; dwData++)
	{
		wData = (WORD)(((double)0x7fff * sin((double)dwData / 180.0 * 3.14159)) + 0x8000);

		wWork = ~wData;
		wWork = wWork & 0x8000;
		wData = wData & 0x7FFF;
		wData = wData | wWork;

		(*ppwData)[dwData] = wData;
	}

	*pdwDataCount = dwDataCount;
}

/*--------------------------------------------------------------------------*/
/*	ʂ\															*/
/*--------------------------------------------------------------------------*/
static void ResultMessage(LPCTSTR lpszbuf)
{
	MessageBox(NULL, lpszbuf, szTitle, MB_OK | MB_ICONINFORMATION);
}

/*--------------------------------------------------------------------------*/
/*	G[bZ[W\													*/
/*--------------------------------------------------------------------------*/
static void ErrorMessage(WORD wLogSlot)
{
	DWORD dwRes = Aisa25wGetLastError(wLogSlot);
	TCHAR szbuf[50];

	switch (dwRes)
	{
		case AISA25_ERR_WRAPDLL:
			wsprintf(szbuf, _T("DLL Load error"));
			break;

		default:
			wsprintf(szbuf, _T("aISA-A25 error\n\n")
							_T("Error code: %d"),
							dwRes);
			break;
	}

	MessageBox(NULL, szbuf, szTitle, MB_OK | MB_ICONSTOP);
}
